# SoCenterballDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoCenterballDragger.h>`

Inheritance diagram for SoCenterballDragger:

List of all members.

## Detailed Description

The SoCenterballDragger class is a dragger you can rotate and translate.

Here's how the dragger looks with it's default geometry in the inactive state:

For rotation, click either the ball "bands" to constrain rotation to happen around the normal vector of the disc, or anywhere else on the (invisible) ball for free-form rotation.

Translation is done by clicking and dragging any of the four arrow markers. Hold `SHIFT` to constrain translation to a single axis instead of in the plane.

When translating, instead of modifying the translation part of the motion matrix, a center field is updated, and the geometry is moved using an internal transformation node.

Here's a simple usage example, in the form of a scene graph as an iv-file:

      #Inventor V2.1 ascii

      Separator {

         # The dragger, offset a little bit against the geometry to clip,
         # so as to not mess up the user interface.
         Separator {
            Translation { translation -4 0 0 }
            DEF cbdragger CenterballDragger { }
         }

         # The clipping plane sub-graph.
         TransformSeparator {

            # Connect transformations to those of the dragger.
            Rotation { rotation 0 0 1 0 = USE cbdragger . rotation }
            Translation { translation 0 0 0 = USE cbdragger . center }

            # Use a simple lineset-based indicator to show how the
            # clipping plane is situated in space.
            Coordinate3 {
               point [
                0 2 2, 0 2 -2,
                0 -2 2, 0 -2 -2,
                0 2 -2, 0 -2 -2,
                0 2 2, 0 -2 2
             ]
            }
            LineSet { numVertices [ 2, 2, 2, 2 ] }

            ClipPlane { }
         }

         # Then follows the geometry that gets clipped. For this
         # example, we use a simple sphere.

         Sphere { }
      }

## Public Member Functions

| SoCenterballDragger (void)
virtual void | saveStartParameters (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | rotation
SoSFVec3f | center

## Protected Member Functions

| ~SoCenterballDragger ()
void | transferCenterDraggerMotion (SoDragger *childdragger)
void | setSwitches (SoDragger *activechild)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)

## Static Protected Member Functions

void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)
void | kidStartCB (void *f, SoDragger *d)
void | kidFinishCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | rotFieldSensor
SoFieldSensor * | centerFieldSensor

## Constructor & Destructor Documentation

SoCenterballDragger::SoCenterballDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoCenterballDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "translateToCenter"
      -->      "surroundScale"
      -->      "antiSquish"
      -->      "lightModel"
               "geomSeparator"
      -->         "XAxisSwitch"
      -->            "XAxis"
      -->         "YAxisSwitch"
      -->            "YAxis"
      -->         "ZAxisSwitch"
      -->            "ZAxis"
      -->      "rotator"
      -->      "YRotator"
      -->      "ZCenterChanger"
      -->      "rotX90"
      -->      "ZRotator"
      -->      "YCenterChanger"
      -->      "rotY90"
      -->      "XCenterChanger"
      -->      "rot2X90"
      -->      "XRotator"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoCenterballDragger
      PVT   "this",  SoCenterballDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
            "translateToCenter",  SoMatrixTransform  ---
            "surroundScale",  SoSurroundScale  ---
            "antiSquish",  SoAntiSquish  ---
            "lightModel",  SoLightModel  ---
      PVT   "geomSeparator",  SoSeparator  ---
            "rotator",  SoRotateSphericalDragger  ---
            "YRotator",  SoRotateCylindricalDragger  ---
            "ZCenterChanger",  SoTranslate2Dragger  ---
      PVT   "rotX90",  SoRotation  ---
            "ZRotator",  SoRotateCylindricalDragger  ---
            "YCenterChanger",  SoTranslate2Dragger  ---
      PVT   "rotY90",  SoRotation  ---
            "XCenterChanger",  SoTranslate2Dragger  ---
      PVT   "rot2X90",  SoRotation  ---
      PVT   "XAxisSwitch",  SoSwitch  ---
            "XAxis",  SoSeparator  ---
      PVT   "YAxisSwitch",  SoSwitch  ---
            "YAxis",  SoSeparator  ---
      PVT   "ZAxisSwitch",  SoSwitch  ---
            "ZAxis",  SoSeparator  ---
            "XRotator",  SoRotateCylindricalDragger  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoCenterballDragger::~SoCenterballDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoCenterballDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

void SoCenterballDragger::saveStartParameters | ( | void |  | ) | `[virtual]`

| This is invoked to save start parameters, to enable draggers to calculate relative motion. Default method in superclass SoDragger just saves the motion matrix, but subclasses should overload this method if other data needs to be saved. Reimplemented from SoDragger.

void SoCenterballDragger::transferCenterDraggerMotion | ( | SoDragger * | childdragger | ) | `[protected]`

| Should be called after motion matrix has been updated by a child dragger.

void SoCenterballDragger::setSwitches | ( | SoDragger * | activechild | ) | `[protected]`

| Sets values for the internal SoSwitch parts. If activechild == `NULL`, all feedback is deactivated.

SbBool SoCenterballDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoCenterballDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it's of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

void SoCenterballDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoCenterballDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoCenterballDragger::kidStartCB | ( | void * | d,
|  | SoDragger * | child
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Needed to activate some feedback.

void SoCenterballDragger::kidFinishCB | ( | void * | d,
|  | SoDragger * | child
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Needed to deactive some feedback.

void SoCenterballDragger::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[protected, virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoDragger.

void SoCenterballDragger::getMatrix | ( | SoGetMatrixAction * | action | ) | `[protected, virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoDragger.

## Member Data Documentation

SoSFRotation SoCenterballDragger::rotation

| This field is continuously updated to contain the rotation of the ball.

SoSFVec3f SoCenterballDragger::center

| Continuously updated to contain the current translation from the dragger's internal local origo position.

SoFieldSensor * SoCenterballDragger::rotFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoCenterballDragger::centerFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoCenterballDragger.h
- SoCenterballDragger.cpp